Bug 41629 - [OOP] gimplification error on valid code
[OOP] gimplification error on valid code
Status: RESOLVED FIXED
Product: gcc
Classification: Unclassified
Component: fortran
4.5.0
: P3 normal
: ---
Assigned To: janus
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2009-10-08 07:51 UTC by janus
Modified: 2009-10-18 12:25 UTC (History)
1 user (show)

See Also:
Host:
Target:
Build:
Known to work:
Known to fail:
Last reconfirmed: 2009-10-09 07:25:55


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description janus 2009-10-08 07:51:52 UTC
The following code results in a gimplication error:

 type t1
   integer :: comp
 end type

 type(t1), target :: a

 class(t1) :: x
 pointer :: x

 a%comp = 3
 x => a
 print *,x%comp

end


The problem here is that 'encapsulate_class_symbol' is called too early (i.e. before the symbol has acquired the pointer attribute). Solution: encapsulate_class_symbol must be called at resolution stage.
Comment 1 Paul Thomas 2009-10-17 18:09:43 UTC
Subject: Bug 41629

Author: pault
Date: Sat Oct 17 18:09:25 2009
New Revision: 152955

URL: http://gcc.gnu.org/viewcvs?root=gcc&view=rev&rev=152955
Log:
2009-10-17  Janus Weil  <janus@gcc.gnu.org>
	    Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/41608
	* decl.c (gfc_match_data_decl): Add BT_CLASS for undefined type
	and empty type errors.
	* parse.c (gfc_build_block_ns): Only set recursive if parent ns
	has a proc_name.

	PR fortran/41629
	PR fortran/41618
	PR fortran/41587
	* gfortran.h : Add class_ok bitfield to symbol_attr.
	* decl.c (build_sym): Set attr.class_ok if dummy, pointer or
	allocatable.
	(build_struct): Use gfc_try 't' to carry errors past the call
	to encapsulate_class_symbol.
	(attr_decl1): For a CLASS object, apply the new attribute to
	the data component.
	* match.c (gfc_match_select_type): Set attr.class_ok for an
	assigned selector.
	* resolve.c (resolve_fl_variable_derived): Check a CLASS object
	is dummy, pointer or allocatable by testing the class_ok and
	the use_assoc attribute.

2009-10-17  Janus Weil  <janus@gcc.gnu.org>
	    Paul Thomas  <pault@gcc.gnu.org>

	PR fortran/41629
	* gfortran.dg/class_6.f90: New test.

	PR fortran/41608
	PR fortran/41587
	* gfortran.dg/class_7.f90: New test.

	PR fortran/41618
	* gfortran.dg/class_8.f90: New test.


Added:
    trunk/gcc/testsuite/gfortran.dg/class_6.f03
    trunk/gcc/testsuite/gfortran.dg/class_7.f03
    trunk/gcc/testsuite/gfortran.dg/class_8.f03
Modified:
    trunk/gcc/fortran/ChangeLog
    trunk/gcc/fortran/decl.c
    trunk/gcc/fortran/gfortran.h
    trunk/gcc/fortran/match.c
    trunk/gcc/fortran/parse.c
    trunk/gcc/fortran/resolve.c
    trunk/gcc/testsuite/ChangeLog

Comment 2 Paul Thomas 2009-10-18 12:25:37 UTC
Fixed on trunk.

Thanks for the report!

Paul